﻿using System;
using System.Linq;
using UnityEngine;
using HMLLibrary;

public class M4A1 : WeaponBase
{
    public static Item_Base item;

    /*[ConsoleCommand]
    public static void setanim(string[] args)
    {
        // setanim aiming/idle gameobjectname x y z
        if (args.Length != 5)
        {
            if (args.Length == 2)
            {
                Quaternion rot;
                WeaponBase _weapon = FindObjectOfType<WeaponBase>();
                bool _aiming = args[0].ToLower() == "aiming";
                if (_aiming)
                {
                    rot = _weapon.skeletonObjects_aiming[args[1]].rotation;
                }
                else
                {
                    rot = _weapon.skeletonObjects_idling[args[1]].rotation;
                }
                Debug.Log("Current rotation for transform '" + args[1] + "' is : " + rot.eulerAngles);
                return;
            }
            else
            {
                Debug.LogWarning("Wrong Syntax! syntax : 'setanim <aiming/idle> <transform name> <x> <y> <z>'");
                return;
            }
        }
        bool aiming = args[0].ToLower() == "aiming";
        string transformName = args[1];
        float x = float.Parse(args[2]);
        float y = float.Parse(args[3]);
        float z = float.Parse(args[4]);
        WeaponBase weapon = FindObjectOfType<WeaponBase>();

        if (aiming)
        {
            if (!weapon.skeletonObjects_aiming.ContainsKey(transformName))
            {
                weapon.skeletonObjects_aiming.Add(transformName, new TransformRotAnimation(weapon.parentTransform.FindChildRecursively(transformName), Quaternion.Euler(x, y, z)));
            }
            else
            {
                weapon.skeletonObjects_aiming[transformName] = new TransformRotAnimation(weapon.parentTransform.FindChildRecursively(transformName), Quaternion.Euler(x, y, z));
            }
        }
        else
        {
            if (!weapon.skeletonObjects_idling.ContainsKey(transformName))
            {
                weapon.skeletonObjects_idling.Add(transformName, new TransformRotAnimation(weapon.parentTransform.FindChildRecursively(transformName), Quaternion.Euler(x, y, z)));
            }
            else
            {
                weapon.skeletonObjects_idling[transformName] = new TransformRotAnimation(weapon.parentTransform.FindChildRecursively(transformName), Quaternion.Euler(x, y, z));
            }
        }
    }

    public static Vector3 pos;
    public static Quaternion rot;*/

    public static async void Initialize()
    {
        item = await WeaponsMod.assetbundle.TaskLoadAssetAsync<Item_Base>("M4A1_Item_Base");
        RAPI.RegisterItem(item);
        GameObject gobject = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("M4A1_Prefab");
        M4A1 script = gobject.AddComponent<M4A1>();

        // Set default values
        script.currentItem = item;
        script.shootAudioClip = await WeaponsMod.assetbundle.TaskLoadAssetAsync<AudioClip>("m4a1_shoot");
        script.reloadAudioClip = await WeaponsMod.assetbundle.TaskLoadAssetAsync<AudioClip>("m4a1_reload");
        script.emptyClipAudioClip = WeaponsMod.emptyAudioClip;
        script.muzzleflashPrefab = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("Glock18_MuzzleFlash");

        script.shootingPoint = gobject.transform.Find("Gun").Find("ShootingPoint").gameObject;
        script.muzzleFlash = script.shootingPoint.transform.Find("Muzzleflash").gameObject;

        script.ammoType = ItemManager.GetItemByName("WeaponsMod_RifleAmmo");
        script.idle_weapon_position = new Vector3(0.09f, -0.01f, -0.05f);
        script.idle_weapon_rotation = Quaternion.Euler(90f, 0f, 90f);
        script.aiming_weapon_position = new Vector3(0, 0, -0.20f);
        script.aiming_weapon_rotation = Quaternion.Euler(90, 0, 0);
        script.clipSize = 30;
        script.damagePerShot = 4;
        script.range = 40f;
        script.shootingDelay = 0.11f;
        script.reloadDelay = 3500f;

        RAPI.SetItemObject(item, gobject);
    }

    public override void PostAiming()
    {
        if (parentTransform == null)
        {
            parentTransform = transform.GetComponentInParent<PlayerAnimator>().transform;
            return;
        }

        if (!skeletonObjects_aiming.ContainsKey("ORG-hand_R"))
        {
            skeletonObjects_aiming.Add("ORG-hand_R", new TransformRotAnimation(parentTransform.FindChildRecursively("ORG-hand_R"), Quaternion.Euler(355, 325, 354)));
            return;
        }

        if (!skeletonObjects_aiming.ContainsKey("ORG-upper_arm_L"))
        {
            skeletonObjects_aiming.Add("ORG-upper_arm_L", new TransformRotAnimation(parentTransform.FindChildRecursively("ORG-upper_arm_L"), Quaternion.Euler(80, 111, 178)));
            return;
        }

        if (!skeletonObjects_aiming.ContainsKey("ORG-forearm_R"))
        {
            skeletonObjects_aiming.Add("ORG-forearm_R", new TransformRotAnimation(parentTransform.FindChildRecursively("ORG-forearm_R"), Quaternion.Euler(352, 45, 0)));
            return;
        }

        skeletonObjects_aiming.ToList().ForEach(k =>
        {
            k.Value.transform.localRotation = k.Value.rotation;
        });

    }

    public override void PostIdling()
    {
        if (parentTransform == null)
        {
            parentTransform = transform.GetComponentInParent<PlayerAnimator>().transform;
            return;
        }

        skeletonObjects_idling.ToList().ForEach(k =>
        {
            k.Value.transform.localRotation = k.Value.rotation;
        });
    }
}