﻿using System;
using System.Linq;
using UnityEngine;
using HMLLibrary;

public class Mac11 : WeaponBase
{
    public static Item_Base item;

    public static async void Initialize()
    {
        item = await WeaponsMod.assetbundle.TaskLoadAssetAsync<Item_Base>("Mac11_Item_Base");
        RAPI.RegisterItem(item);
        GameObject gobject = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("Mac11_Prefab");
        Mac11 script = gobject.AddComponent<Mac11>();

        // Set default values
        script.currentItem = item;
        script.shootAudioClip = await WeaponsMod.assetbundle.TaskLoadAssetAsync<AudioClip>("Mac11_shoot");
        script.reloadAudioClip = await WeaponsMod.assetbundle.TaskLoadAssetAsync<AudioClip>("Mac11_reload");
        script.emptyClipAudioClip = WeaponsMod.emptyAudioClip;
        script.muzzleflashPrefab = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("Glock18_MuzzleFlash");

        script.shootingPoint = gobject.transform.Find("Gun").Find("ShootingPoint").gameObject;
        script.muzzleFlash = script.shootingPoint.transform.Find("Muzzleflash").gameObject;

        script.ammoType = ItemManager.GetItemByName("WeaponsMod_RifleAmmo");
        script.idle_weapon_position = new Vector3(0.09f, -0.01f, 0f);
        script.idle_weapon_rotation = Quaternion.Euler(90f, 0f, 90f);
        script.aiming_weapon_position = new Vector3(0, 0, -0.15f);
        script.aiming_weapon_rotation = Quaternion.Euler(90, 5, 0);
        script.clipSize = 30;
        script.damagePerShot = 3;
        script.range = 40f;
        script.shootingDelay = 0.075f;
        script.reloadDelay = 3000f;

        RAPI.SetItemObject(item, gobject);
    }

    public override void PostAiming()
    {
        if (parentTransform == null)
        {
            parentTransform = transform.GetComponentInParent<PlayerAnimator>().transform;
            return;
        }

        if (!skeletonObjects_aiming.ContainsKey("ORG-hand_R"))
        {
            skeletonObjects_aiming.Add("ORG-hand_R", new TransformRotAnimation(parentTransform.FindChildRecursively("ORG-hand_R"), Quaternion.Euler(-17, -24, 0)));
            return;
        }

        if (!skeletonObjects_aiming.ContainsKey("ORG-upper_arm_L"))
        {
            skeletonObjects_aiming.Add("ORG-upper_arm_L", new TransformRotAnimation(parentTransform.FindChildRecursively("ORG-upper_arm_L"), Quaternion.Euler(80f, 111, 178f)));
            return;
        }

        skeletonObjects_aiming.ToList().ForEach(k =>
        {
            k.Value.transform.localRotation = k.Value.rotation;
        });
    }

    public override void PostIdling()
    {
        if (parentTransform == null)
        {
            parentTransform = transform.GetComponentInParent<PlayerAnimator>().transform;
            return;
        }

        skeletonObjects_idling.ToList().ForEach(k =>
        {
            k.Value.transform.localRotation = k.Value.rotation;
        });
    }

}