﻿using Steamworks;
using System;
using UnityEngine;

[Serializable]
public class WMessage_Shoot : Message
{
    public string shootSound;
    public string GroundParticleEffect;
    public string MuzzleParticleEffect;
    public bool hit;

    public CSteamID player;
    public string currentItem;
    public string script;

    public Vector3 hitPosition
    {
        get
        {
            return new Vector3(hposX, hposY, hposZ);
        }
        private set
        {
            hposX = value.x;
            hposY = value.y;
            hposZ = value.z;
        }
    }
    private float hposX;
    private float hposY;
    private float hposZ;
    public Vector3 hitRotation
    {
        get
        {
            return new Vector3(hrotX, hrotY, hrotZ);
        }
        private set
        {
            hrotX = value.x;
            hrotY = value.y;
            hrotZ = value.z;
        }
    }
    private float hrotX;
    private float hrotY;
    private float hrotZ;

    public WMessage_Shoot(Messages type, bool _hit, string _shootSound, string _GroundParticleEffect, string _MuzzleParticleEffect, Vector3 _hitPosition, Vector3 _hitRotation, CSteamID _player, string _currentItem, string _script) : base(type)
    {
        hit = _hit;
        shootSound = _shootSound;
        GroundParticleEffect = _GroundParticleEffect;
        hitPosition = _hitPosition;
        hitRotation = new Vector3(_hitRotation.x, _hitRotation.y, _hitRotation.z);
        MuzzleParticleEffect = _MuzzleParticleEffect;
        script = _script;
        player = _player;
        currentItem = _currentItem;
    }
}
