﻿using Steamworks;
using System;
using UnityEngine;

[Serializable]
public class WMessage_ThrowDynamite : Message
{
    public CSteamID player;
    public Vector3 throwPosition
    {
        get
        {
            return new Vector3(hposX, hposY, hposZ);
        }
        private set
        {
            hposX = value.x;
            hposY = value.y;
            hposZ = value.z;
        }
    }
    private float hposX;
    private float hposY;
    private float hposZ;

    public Quaternion throwRotation
    {
        get
        {
            return Quaternion.Euler(hrotX, hrotY, hrotZ);
        }
        private set
        {
            hrotX = value.x;
            hrotY = value.y;
            hrotZ = value.z;
        }
    }
    private float hrotX;
    private float hrotY;
    private float hrotZ;

    public Vector3 throwDirection
    {
        get
        {
            return new Vector3(dposX, dposY, dposZ);
        }
        private set
        {
            dposX = value.x;
            dposY = value.y;
            dposZ = value.z;
        }
    }
    private float dposX;
    private float dposY;
    private float dposZ;

    public WMessage_ThrowDynamite(Messages type, CSteamID _player, Vector3 pos, Quaternion rot, Vector3 dir) : base(type)
    {
        player = _player;
        throwPosition = pos;
        throwRotation = rot;
        throwDirection = dir;
    }
}
