﻿using Steamworks;
using System;
using UnityEngine;
using HMLLibrary;

public class SmokeGrenade : MonoBehaviour
{
    public static double delay = 1.0f;
    public DateTime latestThrow;
    public static float trust = 750f;

    public static AudioClip fuseAudioClip;
    public string color = "Blue";

    public static async void Initialize(string _color)
    {
        Item_Base item = await WeaponsMod.assetbundle.TaskLoadAssetAsync<Item_Base>("SmokeGrenade" + _color + "_Item_Base");
        RAPI.RegisterItem(item);
        GameObject gobject = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("SmokeGrenade" + _color + "_Prefab");
        SmokeGrenade script = gobject.AddComponent<SmokeGrenade>();
        script.color = _color;
        RAPI.SetItemObject(item, gobject);
        fuseAudioClip = await WeaponsMod.assetbundle.TaskLoadAssetAsync<AudioClip>("smokegrenade");
    }

    public void Update()
    {
        transform.localPosition = new Vector3(0.09f, -0.01f, 0f);
        transform.localRotation = Quaternion.Euler(90f, 0f, 90f);
        if (CanvasHelper.ActiveMenu != MenuType.None || !GetComponentInParent<Network_Player>().IsLocalPlayer)
        {
            return;
        }
        if (MyInput.GetButtonDown("LMB") && latestThrow.AddSeconds(delay) < DateTime.Now)
        {
            latestThrow = DateTime.Now;
            ThrowSmoke();
            RAPI.GetLocalPlayer().Inventory.RemoveItem("WeaponsMod_SmokeGrenade" + color, 1);
        }
    }

    public async void ThrowSmoke()
    {
        GameObject smokePrefab = await WeaponsMod.assetbundle.TaskLoadAssetAsync<GameObject>("SmokeGrenade" + color + "_ThrowablePrefab");
        smokePrefab.AddComponent<ThrowableSmoke>();
        GameObject smoke = Instantiate(smokePrefab, transform.position, transform.rotation, null);
        smoke.GetComponent<Rigidbody>().AddForce(RAPI.GetLocalPlayer().Camera.transform.forward * trust);
        AudioSource audiosource = smoke.AddComponent<AudioSource>();
        audiosource.spatialBlend = 1;
        audiosource.clip = fuseAudioClip;
        audiosource.Play();

        Destroy(smoke, 60f);

        MessageHandler.SendMessage(new WMessage_ThrowSmoke((Messages)WeaponsMod.NetworkMessages.WeaponsMod_ThrowSmoke, SteamUser.GetSteamID(), transform.position, transform.rotation, RAPI.GetLocalPlayer().Camera.transform.forward, color));
    }
}

